from __future__ import annotations

import pytermgui as ptg

from common import FocusedWindowDebugger, MouseDebugger, set_default_styles


class ScrollContainer(ptg.Window):
    overflow = ptg.Overflow.SCROLL

    def select(self, index: int | None) -> None:
        old = self.selected_index

        super().select(index)

        if self.selected is None:
            return

        if self.selected.pos[1] - self.pos[1] > self.content_dimensions[1]:
            diff = self.selected_index - old
            self.scroll(self.selected_index - old)


def main() -> None:
    with ptg.WindowManager() as manager:
        window = ScrollContainer(
            *(ptg.Button(f"[@{color}]Button") for color in range(256))
        )
        window.height = 20

        manager.add(window)
        manager.run()


if __name__ == "__main__":
    main()
